VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTBRestrNumbers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor: Spatzenkanonier <eckardahlers@freenet.de>

'"TBRestriction-Klassen" schrnken die Eingabemglichkeiten einer Textbox auf den gewnschten _
Verwendungszweck ein. Analoge Klassen sind fr andere Zwecke vorstellbar.
'Hier: nur numerische Werte zulassen (Ziffern und ggfs. 1 Trennzeichen (Delimiter))
'Kontrolliert wird das _Change-Ereignis der Textbox; dadurch werden auch Fehleingaben verhindert, _
die durch Copy-Paste in die Textbox gelangen knnten (vgl. Tipp 297 / 298)
'An Init werden die erlaubten Ziffern (Auch Hex mglich) als sAllowed$ bergeben, und das _
(ebenfalls frei whlbare) Ziffer-Trennzeichen als sDelimiter$.
'sDelimiter$="" bewirkt Beschrnkung auf Ganzzahlen
'sDelimiter$=":" kann man als kleine Stunden-Minuten-Maske einsetzen.
'Eingaben der Komma-Taste werden durch den Delimiter ersetzt, sodass die Eingabe komplett ber den _
Ziffernblock erfolgen kann.

Option Explicit
Option Compare Text

Private txtTB As VB.TextBox
Private WithEvents txtTmpTB As VB.TextBox
Attribute txtTmpTB.VB_VarHelpID = -1
Private Allowed$
Private Delimiter$

Public Sub Init(TB As VB.TextBox, sAllowed$, Optional sDelimiter$)
Allowed = sAllowed & sDelimiter
If sDelimiter = "" Then
    Delimiter = "^"   'bei Nichtangabe eines Delimiters wird er auf ein unerlaubtes Zeichen gesetzt _
                                                                   und fliegt dadurch auch immer raus
Else
    Delimiter = sDelimiter
End If
With TB
    .SelStart = Len(.Text)
    TextCheck TB
    Set txtTB = TB
    Set txtTmpTB = TB
End With
End Sub



Private Sub TextCheck(TB As TextBox)                                 'Aufwendige Kontrolle des Textes
Dim CPos%, I%, C$, SelStartClone&, ProtectedDelimiterPos&
Dim TextClone$, sBefore$
With TB
    SelStartClone = .SelStart 'Zuweisungen an .Text, .SelStart, .SelLength verndern die vorhandene _
                                                              Markierung, und sind daher zu vermeiden
    TextClone = .Text
    TextClone = Replace(TextClone, ",", Delimiter)            'Kommata werden durch Delimiter ersetzt
'-------- _Change() kann neue Delimiter gebracht haben. Wir knnen aber nur einen gebrauchen. Wir _
nehmen bevorzugt den, der nchstlinks von SelStartClone liegt, da SelStartClone immer direkt _
hinter neu eingegebenen Zeichen eingestellt ist. Findet sich links von SelStartClone kein _
Delimiter, so nehmen wir den nchstbesten. die anderen werden gelscht.------------
    ProtectedDelimiterPos = InstrPrev(TextClone, Delimiter, SelStartClone)   'Position des nchsten _
                                                                   Delimiters links von SelStartClone
    If ProtectedDelimiterPos Then
        sBefore = Replace(Left(TextClone, ProtectedDelimiterPos - 1), Delimiter, "")     'Delimiter _
                                                                 links von SelStartClone rausscmeien
        SelStartClone = SelStartClone + Len(sBefore) - (ProtectedDelimiterPos - 1)     'verkleinert _
                                   SelStartClone um die Anzahl der vor SelStartClone liegenden, nun _
                                                                          rausgeschmissenen Delimiter
        TextClone = sBefore & Delimiter & _
                Replace(TextClone, Delimiter, "", Start:=ProtectedDelimiterPos + 1)      'Delimiter _
                                                               rechts von SelStartClone rausschmeien
    Else                                             'Kein Delimiter links von SelStartClone gefunden
        TextClone = Replace(TextClone, Delimiter, "^", Count:=1)          'den nchstbesten maskieren
        TextClone = Replace(TextClone, Delimiter, "")                          'alle anderen wegfegen
        TextClone = Replace(TextClone, "^", Delimiter)                                   'demaskieren
    End If
'--------- Zeichen bis SelStartClone einzeln auf Zulssigkeit checken --------
    I = 1
    Do While I <= SelStartClone
        C = Mid(TextClone, I, 1)
        If InStr(Allowed, C) Then
            I = I + 1
        Else                                                                          'nicht zulssig
            TextClone = Left(TextClone, I - 1) & Mid(TextClone, I + 1)             'Zeichen entfernen
            SelStartClone = SelStartClone - 1                                  'Endmarke vorversetzen
        End If
    Loop
'-------------- einem Delimiter zum Textbeginn wird automatisch eine 0 vorangestellt ----------------
    If Left(TextClone, 1) = Delimiter Then
        TextClone = "0" & TextClone
        SelStartClone = SelStartClone + 1
    End If
'-------------- Text und Cursor neu festlegen --------------------------
    .Text = TextClone
    .SelStart = SelStartClone
End With
End Sub

Private Sub txtTmpTB_Change()
Set txtTmpTB = Nothing          'Ereignisverarbeitung abschalten (ansonsten lst TextCheck() erneut _
                                                                 _Change() aus, bis in alle Ewigkeit)
With txtTB
    TextCheck txtTB
End With
Set txtTmpTB = txtTB                                          'Ereignisverarbeitung wieder anschalten
End Sub

'------------------------ Helpers -----------------------

Function InstrPrev&(ByVal Text$, sMatch$, LastPos&)    'gibt die Position einer bereinstimmung vor _
                                                                                      LastPos& zurck
InstrPrev = InStrRev(Left(Text, LastPos), sMatch)
End Function

